/* Seahorse
 *
 * Copyright (C) 1999, 2000 Anthony Mulcahy
 *   
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


#include <gnome.h>

GtkWidget	*errorbox;
GtkWidget	*genkey_druid;
GtkWidget	*key_manager;
GtkWidget	*main_win;


void load_config ();


/* We don't need this code
 * struct key_struct {
	char	type[4];
	char 	id[9];
	int	ownertrust;
	char	*user;
	int	data_index;
	char	**data;
	int	uid_cnt;
	char	expires[11];
};

struct keyring_struct {
	int pubkey_cnt;
	int seckey_cnt;
	struct key_struct	*public_keys;
	struct key_struct	*secret_keys;
};


struct keyring_struct my_key_ring;

*/

GList *MyKeyring;


enum {
  TARGET_URI_LIST,
  TARGET_URL
};

gint check_entry (GtkWidget *widget, gchar **text);

gint check_free_entry (GtkWidget *widget, gchar **text);


GList*
make_name_list			();

GList*
make_secretkey_list		();

int
read_from_file(int fd);

void
encrypt_fs_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
decrypt_fs_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_sign_encrypt_activate               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_sign_encrypt_file_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_ascii_arm_btn_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sign_encrypt_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_sign_encrypt_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_verify_decrypt_activate             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_verify_decrypt_file_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_verify_decrypt_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_verify_decrypt_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_encrypt_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_decrypt_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_key_list_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
encrypt_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
decrypt_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_main_win_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_send_key_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_receive_key_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_sendkey_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_sendkey_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_recvkey_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);


void
on_gen_key_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_genkey_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_genkey_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_sendkey_selectkeyfile_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_recvkey_selectkeyfile_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_sendkey_file_radiobtn_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_recvkey_file_radiobtn_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_errorbox_clicked                    (GnomeDialog     *gnomedialog,
                                        gint             arg1,
                                        gpointer         user_data);

void
on_recvkey_activate                    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_sendkey_activate                    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_genkey_activate                     (GtkEditable     *editable,
                                        gpointer         user_data);

void
recvkeyfs_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
sendkeyfs_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
recvkeyfs_cancel_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
sendkeyfs_cancel_clicked               (GtkButton       *button,
                                        gpointer         user_data);


void
on_decrypt_btn_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_detachedsign_btn_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sign_btn_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_encrypt_btn_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_signencrypt_btn_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


void
on_sign_encrypt_selection_received     (GtkWidget       *widget,
                                        GtkSelectionData *data,
                                        guint            time,
                                        gpointer         user_data);

void
on_decrypt_clipboard_btn_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_verify_decrypt_selection_received   (GtkWidget       *widget,
                                        GtkSelectionData *data,
                                        guint            time,
                                        gpointer         user_data);

void
listkeys_button_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_verify_btn_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_decrypt_btn_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_key_edit_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_key_manager_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanagersign_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_keymanagerlsign_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_keymanagerrevoke_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_revokekey_ok_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
keymanager_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_signkey_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_keys_manager_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_clearsign_btn_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_delkey_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_genkeydruid_next                    (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

void
on_genkeydruid_activate                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_genkeydruid_finish                  (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_genkeydruid_cancel                  (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);


void
on_keyring_itemselect		       (GtkWidget	*root_tree,
					GtkWidget	*child,
					GtkWidget	*subtree);

void
on_subkeyring_itemselect	       (GtkWidget	*root_tree,
					GtkWidget	*child,
					GtkWidget	*subtree);

void
on_paste_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_selectall_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clear_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_data_textbox_selection_received     (GtkWidget       *widget,
                                        GtkSelectionData *data,
                                        guint            time,
                                        gpointer         user_data);


void
on_signencrypt_outfile_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_verifydecrypt_outfile_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_outfilese_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_outfilevd_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_delsig_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_encryptfile_btn_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_encryptclipboard_btn_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_encrypttextarea_btn_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_decryptclipboard_btn_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_decryptfile_btn_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_decrypttextarea_btn_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_outtextse_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_outfilese_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
encrypt_outfs_btn_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_outtextvd_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_outfilevd_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
decrypt_outfs_btn_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_changetrust_ok_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_changetrust_cancel_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_trustmenuval_activate               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_trustgrp_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_keys_manager_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_textmode_btn_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sign_encrypt_drag_data_received     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_verify_decrypt_drag_data_received   (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_signencrypt_outfile_drag_data_received
                                        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_sign_encrypt_file_drag_data_received
                                        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_verifydecrypt_outfile_drag_data_received
                                        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_verify_decrypt_file_drag_data_received
                                        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_data_textbox_drag_data_received     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_keymanageradduid_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_adduid_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button11_drag_data_received         (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_button12_drag_data_received         (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_deluid_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

gint
on_key_manager_close                   (GnomeDialog     *gnomedialog,
                                        gpointer         user_data);

void
on_preferences_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_pref_default_key_activate           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_prefdialog_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_prefdialog_apply_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_prefdialog_cancel_clicked           (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_key_press_event                     (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_find1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_find_again1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_finddialog_activate                 (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_finddialog_find_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_finddialog_close_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_find_string_text_activate           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_keymanagerexpiry_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_changeexpiry_activate               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_changeexpiry_ok_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_changeexpiry_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_pref_default_key_activate           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_keymanager_file_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanager_key_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanager_properties_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanager_exit_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanager_prefs_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanager_help_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_keymanager_about_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_newkey_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_properties_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_newkey_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_properties_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_pref_enable_comment_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_pref_default_cipher_activate        (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_pref_enable_comment_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_pref_default_cipher_activate        (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_ownertrust_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_ctree_tree_select_row               (GtkCTree        *ctree,
                                        GList           *node,
                                        gint             column,
                                        gpointer         user_data);

void
on_adduid_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_revoke_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_importkey_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_exportkey_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_sign_button_clicked				(GtkButton	*button,
								gpointer		user_data);
								
void
on_ctree_tree_unselect_row			(GtkCTree		*ctree,
								GList           *node,
								gint             column,
                                        gpointer         user_data);

void
on_signkey_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_changepass_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_chgpass_cancel_button_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_delkey_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_delkey_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_deluid_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_deluid_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_delkey_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data);
void
on_ascii_arm_btn2_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_properties_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data);
void
on_recvkey_ok_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_sendkey_ok_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_recvkey_select_file_browse_clicked  (GnomeFileEntry  *gnomefileentry,
                                        gpointer         user_data);

void
on_sendkey_select_file_browse_clicked  (GnomeFileEntry  *gnomefileentry,
                                        gpointer         user_data);

void
on_recvkey_server_radiobtn_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_recvkey_file_radiobtn_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sendkey_server_radiobtn_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_importkey_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_exportkey_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
importkey_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
exportkey_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_sendkey_file_radiobtn_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_changepass_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_signkey_activate                    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_adduidentry_activate                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_revokekey_activate                  (GtkEditable     *editable,
                                        gpointer         user_data);
